# Josh Graphics Library

Yet Another C++ Rendering Toolkit

![Static Badge](https://img.shields.io/badge/Lit-Based-%20)


## Features

* Modern C++ (20)
* Provides single-function-calls to render various graphics primitives in 2D and 3D.
* Integrates directly with our other toolkits (ReWindow, J3ML)
* Quick Rendering of Debug Text, Geometric Widgets, Textures, and so forth.
* Little-to-no overhead.
* Integrates right into an existing OpenGL rendering system.
* High-performance text rendering.

## API Overview

### J2D
* DrawPoint
* DrawLine / DrawGradientLine
* DrawSprite
* OutlineRect / FillRect / FillGradientRect / FillRoundedRect
* OutlineCircle / FillCircle
* OutlineTriangle / FillTriangle
* DrawString
### J3D
* DrawLine
* DrawString
* DrawMatrixGizmo (WIP)
* DrawAxisAngleGizmo (WIP)
* DrawQuaternionGizmo (WIP)

### Types
* Font
* Sprite
* Color4/Color3
* Gradient

## Usage

Install instructions and code samples coming soon :tm: !

## Documentation

Documentation is (sic: will be) automatically generated from latest commit and is hosted at https://doc.redacted.cc/jgl .

## Contributing

Contributions to JGL are welcome! If you find a bug, have a feature request, or would like to contribute code, please submit an issue or pull request to our repository!

## License

JGL is licensed under the Public Domain. See the LICENSE file for details.

## Acknowledgements

JGL is developed and maintained by Josh O'Leary @ Co from Redacted Software and contributors. Special thanks to Redacted.