#pragma once

namespace JGL {
    enum class Direction : u8 {
        None = 0,
        Vertical = 1,
        Horizontal = 2,
        Diagonal_NWSE = 3, // North West -> South East.
        Diagonal_SWNE = 4 // South West -> North East.
    };

    inline Direction operator|(Direction a, Direction b) {
        return static_cast<Direction>(static_cast<int>(a) | static_cast<int>(b));
    }

    inline bool operator&(Direction a, Direction b) {
        return (u8)a & (u8)b;
    }

    static std::string to_string(JGL::Direction direction) {
        switch (direction) {
            case JGL::Direction::None:
                return "None";
            case JGL::Direction::Vertical:
                return "Vertical";
            case JGL::Direction::Horizontal:
                return "Horizontal";
            case JGL::Direction::Diagonal_NWSE:
                return "Diagonal_NWSE";
            case JGL::Direction::Diagonal_SWNE:
                return "Diagonal_SWNE";
            default:
                return "Unknown";
        }
    }
}
